package be.iminds.ilabt.jfed.experimenter_gui.dialogs;

import be.iminds.ilabt.jfed.experimenter_gui.ui.AbstractDialogFactory;
import be.iminds.ilabt.jfed.fedmon.webapi.service.json.Testbed;
import com.google.common.eventbus.EventBus;
import javafx.fxml.FXMLLoader;
import javafx.stage.Stage;
import javafx.util.Pair;

import javax.annotation.Nonnull;
import javax.annotation.Nullable;
import javax.inject.Inject;
import javax.inject.Named;
import javax.inject.Provider;
import javax.inject.Singleton;
import java.net.URL;
import java.time.Instant;
import java.util.Objects;

@Singleton
public class TestbedSiteDialogFactory extends AbstractDialogFactory {
    private String title = "Testbed Site";

    @Inject
    public TestbedSiteDialogFactory(Provider<FXMLLoader> loaderProvider,
                                    @Named("parentStage") Provider<Stage> parentStageProvider,
                                    @Nonnull EventBus eventBus) {
        super(loaderProvider, parentStageProvider);
    }

    @Override
    protected String getTitle() {
        return title;
    }

    @Override
    protected URL getFxmlLocation() {
        return TestbedSiteDialogFactory.class.getResource("TestbedSiteDialog.fxml");
    }

    /**
     * show a testbed dialog. This may return a request RSpec (in order to either open a new editor tab, or add nodes to an existing one).
     * @param testbed
     * @return a request RSpec, or null
     */
    @Nullable
    public String showDialog(@Nonnull Testbed testbed, URL url, String title) {
        this.title = title;
        AbstractDialogFactory.StageAndController stageAndController = this.createStage();
        TestbedSiteDialog controller = (TestbedSiteDialog)stageAndController.getController();
        controller.setUrlAndTestbed(url, testbed, title);

        stageAndController.getStage().showAndWait();

        //TODO
        return null;
    }
}
